Ext.define('demo.view.widget.demoWidget', {extend:'Ext.container.Container', alias:'widget.demoWidget', mixins:['BpcCommon.mixin.Widget'], statics:{WIDGET_NAME:'demo Hello World Widget', WIDGET_DESCRIPTION:'Hello World Description', WIDGET_ICON_CLS:'x-fa fa-bug'}, layout:'card', activeItems:0, widgetConfigSettingMap:{managedSettingWithDefault:{settingType:'text'}, managedSettingWithOUTDefault:{settingType:'number'}}, config:{widgetConfiguration:{unmanagedSetting:'value', managedSettingWithDefault:'default of managedSettingWithDefault'}}, 
viewModel:{data:{vmDataUnmanagedSetting:'nothing1', vmDataManagedSettingWithDefault:'nothing2', vmDataManagedSettingWithOUTDefault:'nothing3'}}, initComponent:function() {
  Ext.log({msg:this.self.getName() + ': initComponent', level:'info'});
  this.initWidgetSettings();
  this.callParent();
  this.content = this.add({xtype:'container', layout:'form', defaults:{xtype:'textfield', readOnly:true}, items:[{fieldLabel:'unmanagedSetting', bind:'{vmDataUnmanagedSetting}'}, {fieldLabel:'managedSettingWithDefault', bind:'{vmDataManagedSettingWithDefault}'}, {fieldLabel:'managedSettingWithOUTDefault', bind:'{vmDataManagedSettingWithOUTDefault}'}]});
  this.settingPanel = this.add({xtype:'bpcSettingPanel', settings:this.settingStore, buttons:[{text:'OK', handler:this.setActiveItem.bind(this, 0)}]});
  this.initWidget();
}, refreshWidget:function() {
  Ext.log({msg:this.self.getName() + ': refreshWidget not implemented for this widget', level:'warn'});
}, configureWidget:function() {
  Ext.log({msg:this.self.getName() + ': configureWidget', level:'info'});
  this.setActiveItem(1);
}, initWidget:function() {
  Ext.log({msg:this.self.getName() + ': initWidget', level:'info'});
  var vm = this.getViewModel();
  vm.set('vmDataUnmanagedSetting', this.getSetting('unmanagedSetting'));
  vm.set('vmDataManagedSettingWithDefault', this.getSetting('managedSettingWithDefault'));
  vm.set('vmDataManagedSettingWithOUTDefault', this.getSetting('managedSettingWithOUTDefault'));
}});
Ext.define('demo.view.widget.demoBasicWidget', {extend:'Ext.Component', statics:{WIDGET_NAME:'demo Basic Widget', WIDGET_DESCRIPTION:'A Widget demo with basic information', WIDGET_ICON_CLS:'x-fa fa-fire'}, html:'Guten Tag'});
Ext.define('demo.view.widget.demoMinimalWidget', {extend:'Ext.Component', html:'Hallo Welt'});
Ext.define('demo.view.widget.Calendar', {extend:'Ext.panel.Panel', layout:'fit', statics:{WIDGET_NAME:'Calendar Demo', WIDGET_DESCRIPTION:'Show a Calendar Widget', WIDGET_ICON_CLS:'x-fal fa-calendar'}, initComponent:function() {
  Ext.log({msg:this.self.getName() + ': initComponent', level:'info'});
  this.items = [{xtype:'calendar', store:{autoLoad:true, proxy:{type:'ajax', url:'bpc-fe-demo/resources/calendars.json', extraParams:{action:'getCalendars'}}}}];
  this.callParent();
}});
Ext.define('demo.BpcInterface', {extend:'BpcCommon.BpcInterface', requires:['demo.view.widget.demoWidget', 'demo.view.widget.demoBasicWidget', 'demo.view.widget.demoMinimalWidget', 'demo.view.widget.Calendar'], config:{moduleConfigurationComponents:[], baseModuleView:null, mainView:null, widgets:['demo.view.widget.demoWidget', 'demo.view.widget.demoBasicWidget', 'demo.view.widget.demoMinimalWidget', 'demo.view.widget.Calendar'], forwardedEvents:['chat']}});
Ext.define('demo.Module', {singleton:true, constructor:function() {
  Ext.log('Loading demo Module...');
}});
Ext.define('demo.newType', {extend:'Ext.form.field.Text', alias:['widget.bpcconfig.newType'], emptyText:'new Test Feld'});
Ext.define('demo.plugin.PluginHook', {extend:'BpcCommon.plugin.HookContainer', alias:'widget.demoPluginHook', inheritableStatics:{NAME:'Demo Hook', HOOK_ID:'demo_hook', MODULE:'demo'}, layout:{type:'hbox', align:'stretch'}});
Ext.define('demo.plugin.column.Column', {extend:'Ext.grid.column.Column', alias:'widget.demoColumnPlugin', text:'✌ Demo Column', producesHTML:false, defaultRenderer:function(value) {
  return '✌' + value + '✌';
}, updater:function(cell, value) {
  Ext.fly(cell).down(this.getView().innerSelector, true).innerHTML = demo.view.plugin.Column.prototype.defaultRenderer.call(this, value);
}});
Ext.define('demo.plugin.column.ColumnInterface', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'Demo Column', COMPONENT_XTYPE:'demoColumnPlugin', PLUGIN_ID:'demoColumnPlugin'}});
Ext.define('demo.plugin.demo.Plugin', {extend:'Ext.Component', alias:'widget.demoPlugin', title:'\ud83e\uddd0', html:'✌️ Demo Plugin ✌️', initComponent:function() {
  this.callParent();
  if (Ext.isDefined(this.pluginConfiguration) && Ext.isDefined(this.pluginConfiguration.configuration.pluginMessage)) {
    var htmlString = '✌ \x3cb\x3e' + this.pluginConfiguration.configuration.pluginMessage + ' \x3c/b\x3e ✌️';
    this.setHtml(htmlString);
  }
}});
Ext.define('demo.plugin.demo.PluginInterface', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'Demo Plugin', COMPONENT_XTYPE:'demoPlugin', PLUGIN_ID:'demo_plugin', DEFAULT_CONFIGURATION:{pluginMessage:'Greetings from the plugin Configuration'}}});
Ext.define('demo.plugin.toolbar.Interface', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'Demo Toolbar Plugin', COMPONENT_XTYPE:'demoToolbarPlugin', PLUGIN_ID:'demo_toolbar_plugin', DEFAULT_CONFIGURATION:{iconCls:'x-fal fa-fire'}}});
Ext.define('demo.plugin.toolbar.Plugin', {extend:'Ext.toolbar.Toolbar', alias:'widget.demoToolbarPlugin', initComponent:function() {
  var configureIconCls = 'x-fal fa-question';
  if (Ext.isDefined(this.pluginConfiguration) && Ext.isDefined(this.pluginConfiguration.configuration.iconCls)) {
    configureIconCls = this.pluginConfiguration.configuration.iconCls;
  }
  this.items = [{xtype:'button', itemId:'pluginToolbarButton', iconCls:configureIconCls, handler:function(btn) {
    btn.up('demoToolbarPlugin').down('#pluginToolbarTextfield').setValue((new Date()).toISOString());
  }}, {xtype:'textfield', fieldLabel:'Demo', itemId:'pluginToolbarTextfield', plugins:['bpcDynamicFieldLabel']}];
  this.callParent();
}});
Ext.define('demo.view.Main', {extend:'Ext.Container', layout:'fit', items:[{xtype:'demoOverviewPanel'}], getCurrentModuleState:function() {
  var currentState = {route:BpcCommon.Api.getCurrentNavigationRoute()};
  return currentState;
}});
Ext.define('demo.view.OldMain', {extend:'Ext.container.Container', alias:'widget.demoOldMain', controller:'demoMainController', title:'demo Module', iconCls:'x-fal fa-hand-peace', layout:'border', moduleId:undefined, viewModel:{data:{eins:1, zwei:2, drei:3, wahrheitswert:true, record:undefined, notificationType:'INFO', notificationToast:false, measurement:{no:'data'}}, formulas:{performanceResult:function(get) {
  return JSON.stringify(get('measurement'), undefined, 2);
}}}, items:[{xtype:'panel', scrollable:true, layout:{type:'vbox', align:'stretch'}, region:'center', padding:10, items:[{xtype:'fieldset', collapsible:true, collapsed:true, defaults:{anchor:'100%'}, title:'Data-Binding', items:[{xtype:'textfield', fieldLabel:'Eins', bind:'{eins}'}, {xtype:'textfield', fieldLabel:'Zwei', bind:'{zwei}'}, {xtype:'textfield', fieldLabel:'Drei', bind:'{drei}'}, {xtype:'checkbox', fieldLabel:'Chat?', bind:'{wahrheitswert}'}]}, {xtype:'fieldset', collapsible:true, collapsed:true, 
defaults:{anchor:'100%'}, title:'Monitor Daten', itemId:'monitorData', items:[{xtype:'box', html:'Kein Monitor angebunden'}]}, {xtype:'fieldset', collapsible:true, defaults:{anchor:'100%'}, title:'Notifications', itemId:'notificationFieldSet', items:[{xtype:'textfield', fieldLabel:'Text', bind:'{notificationText}'}, {xtype:'radiogroup', fieldLabel:'Typ', columns:4, bind:'{notificationType}', items:[{boxLabel:'Information', name:'notificationType', inputValue:'INFO'}, {boxLabel:'Warnung', name:'notificationType', 
inputValue:'WARNING'}, {boxLabel:'Fehler', name:'notificationType', inputValue:'ERROR'}, {boxLabel:'Frage', name:'notificationType', inputValue:'QUESTION'}]}, {xtype:'checkboxgroup', fieldLabel:'Optionen', columns:4, items:[{boxLabel:'PopUp', bind:'{notificationPopUp}'}, {boxLabel:'Toast', bind:'{notificationToast}'}, {boxLabel:'Silent', bind:'{notificationSilent}'}]}, {xtype:'radiogroup', fieldLabel:'Toast Ziel', columns:4, bind:{value:'{notificationToastTarget}', disabled:'{!notificationToast}'}, 
items:[{boxLabel:'Global', name:'notificationToastTarget', inputValue:'global', checked:true}, {boxLabel:'Modul', name:'notificationToastTarget', inputValue:'module'}, {boxLabel:'Fieldset', name:'notificationToastTarget', inputValue:'fieldset'}]}, {xtype:'button', iconCls:'x-fal fa-envelope', text:'Senden', handler:'sendNotification'}]}, {xtype:'fieldset', collapsible:true, collapsed:true, defaults:{anchor:'100%'}, title:'Konfigurationsmanagement', items:[{xtype:'colorselector', fieldLabel:'Stage Color'}, 
{xtype:'textfield', fieldLabel:'Modulname', bind:'{moduleNameSetting.value}'}]}, {xtype:'fieldset', collapsible:true, collapsed:true, defaults:{anchor:'100%'}, title:'Perfomance Daten', items:[{xtype:'button', text:'Start', iconCls:'x-fal fa-play', handler:'startMeasure'}, {xtype:'button', text:'Stop', iconCls:'x-fal fa-stop', handler:'stopMeasure'}, {xtype:'textarea', fieldLabel:'Ergebnis', bind:'{performanceResult}', grow:true}]}], buttons:[{xtype:'button', iconCls:'x-fal fa-lock', text:'Sperren', 
buttonType:'applyLock', handler:'applyLock'}, {xtype:'button', iconCls:'x-fal fa-lock-open', text:'Entsperren', handler:'releaseLock'}, {text:'In die Toolbar', iconCls:'x-fal fa-arrow-to-top', handler:'injectButtons'}, '-\x3e', {text:'Chat Demo', iconCls:'x-fal fa-comments', handler:'letsChat'}]}, {region:'west', xtype:'demoTestView', inputParameter:'hello world south', split:true, collapsible:true, collapsed:true, width:150}, {region:'east', xtype:'demoChat', split:true, bind:{hidden:'{!wahrheitswert}'}, 
width:500}], initComponent:function() {
  this.record;
  this.getViewModel().set('record', this.record);
  if (this.moduleId) {
    this.getViewModel().set('moduleNameSetting', BpcCommon.Api.getSetting(this.moduleId, 'module_name', true));
  }
  this.callParent();
}});
Ext.define('demo.view.OldMainController', {extend:'Ext.app.ViewController', alias:'controller.demoMainController', listen:{global:{coreDataUnlocked:'checkLock', coreDataLocked:'checkLock', coreDataLockUpdate:'checkLock'}}, control:{'#':{afterrender:'checkLock'}, 'colorselector':{change:'pickAColor'}}, init:function() {
  this.getViewModel().bind('{record}', this.setMonitorData.bind(this));
  this.getViewModel().bind('{transparence}', this.pickAColor.bind(this, undefined, undefined));
}, setMonitorData:function(record) {
  try {
    if (record) {
      var target = this.getView().down('#monitorData');
      target.removeAll();
      Ext.Object.each(record.getData(), function(key, value) {
        target.add({xtype:'textfield', fieldLabel:key, value:value});
      });
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR setMonitorData', dump:e, stack:true, level:'error'});
  }
}, eineFunktion:function() {
  var connectionId = BpcCommon.Api.getSetting('demo', 'backendConnectionId');
  var endpoint = BpcCommon.Api.getSetting('demo', 'httpEndpoint');
  var connectionUrl = BpcCommon.Api.getBackendUrl(connectionId);
  var vm = this.getViewModel();
  Ext.Ajax.request({url:connectionUrl + '/ibis/servlet/IBISHTTPUploadServlet/' + endpoint, method:'POST', params:{hallo:'welt', status:vm.get('record.STATUS'), text:vm.get('record.TEXT'), processid:vm.get('record.PROCESSID'), user:BpcCommon.Api.getUserName()}, success:this.onSuccess.bind(this), failure:this.onFailure.bind(this)});
  BpcCommon.Api.showNotification('Ist raus');
}, onSuccess:function() {
  Ext.log({msg:this.self.getName() + ': onSuccess', level:'info'});
  BpcCommon.Api.showNotification('OK');
}, onFailure:function() {
  Ext.log({msg:this.self.getName() + ': onFailure', level:'info'});
  BpcCommon.Api.showNotification('Fehler');
}, letsChat:function() {
  Ext.log({msg:this.self.getName() + ': letsChat', level:'info'});
  Ext.create({xtype:'bpcWindow', items:[{xtype:'demoChat'}], title:'demo Demo - Chat', iconCls:'x-fal fa-comments'});
}, applyLock:function() {
  Ext.fireEvent('chat', {text:BpcCommon.Api.getUserName() + ' locked the demo module \ud83d\udd12', user:'✌️Virtimo', date:new Date()});
  BpcCommon.Api.lockData('demo', 'lockdemo');
  this.unlockBtnFn = BpcCommon.Util.blockComponentForAsyncAction('applyLock', 'buttonType');
}, releaseLock:function() {
  Ext.fireEvent('chat', {text:BpcCommon.Api.getUserName() + ' UNlocked the demo module \ud83d\udd13', user:'✌️Virtimo', date:new Date()});
  BpcCommon.Api.unlockData('demo', 'lockdemo');
  if (Ext.isFunction(this.unlockBtnFn)) {
    this.unlockBtnFn();
    delete this.unlockBtnFn;
  }
}, checkLock:function() {
  var lock = BpcCommon.Api.getLockInformation('demo', 'lockdemo');
  if (lock && lock.get('user')) {
    if (BpcCommon.Api.getUserName() === lock.get('user')) {
      if (!this.unlockBtnFn) {
        this.unlockBtnFn = BpcCommon.Util.blockComponentForAsyncAction('applyLock', 'buttonType');
      }
    } else {
      this.getView().mask('Gesperrt durch ' + lock.get('user'));
    }
  } else {
    this.getView().unmask();
    if (Ext.isFunction(this.unlockBtnFn)) {
      this.unlockBtnFn();
      delete this.unlockBtnFn;
    }
  }
}, sendNotification:function() {
  var vm = this.getViewModel();
  var notificationText = Ext.util.Format.date(new Date(), 'H:i:s') + ' ' + vm.get('notificationText');
  var toastTarget = undefined;
  if (vm.get('notificationToastTarget') && vm.get('notificationToastTarget').notificationToastTarget === 'module') {
    toastTarget = this.getView();
  } else if (vm.get('notificationToastTarget') && vm.get('notificationToastTarget').notificationToastTarget === 'fieldset') {
    toastTarget = this.getView().down('#notificationFieldSet');
  }
  BpcCommon.Api.showNotification({text:notificationText, type:vm.get('notificationType').notificationType, popUp:vm.get('notificationPopUp'), toast:vm.get('notificationToast'), toastTarget:toastTarget, silent:vm.get('notificationSilent')});
}, pickAColor:function(colorSelector) {
  var setting = BpcCommon.Api.getSetting('_core', 'gui_stageColor', true);
  this.lastColor = colorSelector.getValue();
  var transparence = colorSelector.childViewModel.get('alpha');
  var translatedColor = '#' + this.lastColor + Math.ceil(transparence * 2.55).toString(16);
  setting.set('value', translatedColor);
}, injectButtons:function() {
  BpcCommon.Api.addItemToAppToolbar([{xtype:'button', iconCls:'x-fal fa-lock', buttonType:'applyLock', handler:this.applyLock.bind(this)}, {xtype:'button', iconCls:'x-fal fa-lock-open', handler:this.releaseLock.bind(this)}]);
}, startMeasure:function() {
  Ext.log({msg:this.self.getName() + ': startMeasure', level:'info'});
  this.unlockMeasureBtn = BpcCommon.Util.blockComponentForAsyncAction('startMeasure', 'handler');
  BpcCommon.Performance.mark('demo_demo_start');
}, stopMeasure:function() {
  Ext.log({msg:this.self.getName() + ': stopMeasure', level:'info'});
  if (this.unlockMeasureBtn) {
    this.unlockMeasureBtn();
    delete this.unlockMeasureBtn;
    BpcCommon.Performance.mark('demo_demo_end');
    BpcCommon.Performance.measure('demo_demo', 'demo_demo_start', 'demo_demo_end');
    var mArray = performance.getEntriesByType('measure');
    var measurement = mArray[mArray.length - 1];
    var vm = this.getViewModel();
    vm.set('measurement', measurement);
  }
}});
Ext.define('demo.view.TestView', {extend:'Ext.panel.Panel', alias:'widget.demoTestView', inputParameter:'nicht gesetzt', title:'Binded Data', bind:{html:'eins: {eins}\x3cbr\x3ezwei: {zwei}\x3cbr\x3edrei: {drei}'}});
Ext.define('demo.view.chat.Chat', {extend:'Ext.Container', alias:'widget.demoChat', controller:'demoChatController', layout:'border', items:[{region:'center', xtype:'textarea', fieldStyle:"font-family: monospace; background-size: cover; background-image: url('resources/images/bg_2.jpg')", readOnly:true}, {region:'south', xtype:'textfield', fieldLabel:'Text', labelWidth:35, fieldStyle:'font-family: monospace;'}]});
Ext.define('demo.view.chat.ChatController', {extend:'Ext.app.ViewController', alias:'controller.demoChatController', control:{'textfield':{specialkey:'onSpecialKey'}}, listen:{global:{chat:'onChat'}}, init:function() {
  Ext.fireEvent('chat', {text:BpcCommon.Api.getUserName() + ' joined the chat ', user:'✌️Virtimo', date:new Date()});
}, onSpecialKey:function(source, e) {
  Ext.log({msg:this.self.getName() + ': onSpecialKey', level:'info'});
  if (e.getKey() === e.ENTER) {
    Ext.fireEvent('chat', {text:source.getValue(), user:BpcCommon.Api.getUserName(), date:new Date()});
    source.reset();
  }
}, onChat:function(event) {
  Ext.log({msg:this.self.getName() + ': onChat', level:'info'});
  if (!event.properties) {
    return;
  }
  var chatObject = event.properties.data;
  var target = this.getView().down('textarea');
  var oldValue = target.getValue();
  target.setValue(oldValue + '\n' + Ext.Date.format(new Date(chatObject.date), 'H:i:s') + ' - ' + chatObject.user + ': ' + chatObject.text);
}});
Ext.define('demo.AbsoluteDateRangePicker', {extend:'Ext.panel.Panel', alias:'widget.demoAbsoluteDateRangePicker', title:'Absolute Date Range Picker', layout:{type:'vbox', align:'stretch'}, items:[{xtype:'bpcAbsoluteDateRangePicker'}]});
Ext.define('demo.view.components.AccountPlugins', {extend:'Ext.panel.Panel', alias:'widget.demoAccountPlugins', title:'Account Plugins', layout:{type:'vbox'}, items:[{xtype:'bpcAccountToolbar', pluginConfiguration:{configuration:{}}}, {xtype:'bpcAccountToolbar', pluginConfiguration:{configuration:{userTextTpl:'{global.userSession.firstName} {global.userSession.lastName}', userTooltipTpl:'{global.userSession.firstName} {global.userSession.lastName} ({global.userSession.loginName}', changeLanguage:true, 
accountPage:true, logout:true, changePw:true, icon:true, buttonArrow:false, buttonLogout:false}}}, {xtype:'bpcAccountToolbar', pluginConfiguration:{configuration:{userTextTpl:'changeLanguage: true', changeLanguage:true, accountPage:false, logout:false, changePw:false, icon:false, buttonArrow:false, buttonLogout:false}}}, {xtype:'bpcAccountToolbar', pluginConfiguration:{configuration:{userTextTpl:'accountPage: true', changeLanguage:false, accountPage:true, logout:false, changePw:false, icon:false, 
buttonArrow:false, buttonLogout:false}}}, {xtype:'bpcAccountToolbar', pluginConfiguration:{configuration:{userTextTpl:'logout: true', changeLanguage:false, accountPage:false, logout:true, changePw:false, icon:false, buttonArrow:false, buttonLogout:false}}}, {xtype:'bpcAccountToolbar', pluginConfiguration:{configuration:{userTextTpl:'changePw: true', changeLanguage:false, accountPage:false, logout:false, changePw:true, icon:false, buttonArrow:false, buttonLogout:false}}}, {xtype:'bpcAccountToolbar', 
pluginConfiguration:{configuration:{userTextTpl:'icon: true + accountPage: true', changeLanguage:false, accountPage:true, logout:false, changePw:false, icon:true, buttonArrow:false, buttonLogout:false}}}, {xtype:'bpcAccountToolbar', pluginConfiguration:{configuration:{userTextTpl:'buttonArrow: true + accountPage: true', changeLanguage:false, accountPage:true, logout:false, changePw:false, icon:false, buttonArrow:true, buttonLogout:false}}}, {xtype:'bpcAccountToolbar', pluginConfiguration:{configuration:{userTextTpl:'buttonLogout: true + accountPage: true', 
changeLanguage:false, accountPage:true, logout:false, changePw:false, icon:false, buttonArrow:false, buttonLogout:true}}}, {xtype:'button', text:'AccountMenu Plugin Demo', menu:[{xtype:'bpcAccountMenu'}, {xtype:'bpcAccountMenu', pluginConfiguration:{configuration:{userTextTpl:'User {global.userSession.loginName}', userTooltipTpl:'Hello \x3cb\x3eX {global.userSession.firstName} X\x3c/b\x3e'}}}, {xtype:'bpcAccountMenu', pluginConfiguration:{configuration:{userTextTpl:'changeLanguage: true', changeLanguage:true, 
accountPage:false, logout:false, changePw:false, icon:false}}}, {xtype:'bpcAccountMenu', pluginConfiguration:{configuration:{userTextTpl:'accountPage: true', changeLanguage:false, accountPage:true, logout:false, changePw:false, icon:false}}}, {xtype:'bpcAccountMenu', pluginConfiguration:{configuration:{userTextTpl:'logout: true', changeLanguage:false, accountPage:false, logout:true, changePw:false, icon:false}}}, {xtype:'bpcAccountMenu', pluginConfiguration:{configuration:{userTextTpl:'changePw: true', 
changeLanguage:false, accountPage:false, logout:false, changePw:true, icon:false}}}, {xtype:'bpcAccountMenu', pluginConfiguration:{configuration:{userTextTpl:'icon: true', changeLanguage:false, accountPage:false, logout:false, changePw:false, icon:true}}}]}]});
Ext.define('demo.view.components.BpcFields', {extend:'Ext.panel.Panel', alias:'widget.demoBpcFields', title:'BPC Eingabe Felder', layout:{type:'vbox', align:'stretch'}, scrollable:true, items:[{html:'BPC Fields try to avoid XSS by escaping user input.'}, {xtype:'textfield', fieldLabel:'Default Textfield'}, {xtype:'bpcTextField', fieldLabel:'BPC Textfield'}, {xtype:'textarea', fieldLabel:'Default Textarea'}, {xtype:'bpcTextArea', fieldLabel:'BPC Textarea'}, {xtype:'datefield', fieldLabel:'Default Datefield'}, 
{xtype:'bpcDateField', fieldLabel:'BPC Datefield'}, {xtype:'combobox', fieldLabel:'Default Combobox', queryMode:'local', displayField:'name', valueField:'abbr', store:[{abbr:'AL', name:'\x3cb\x3efett\x3c/b\x3e'}, {abbr:'AK', name:'\x3ci\x3eAlaska\x3c/i\x3e'}, {abbr:'AZ', name:'\x26lt;b\x26gt;fettEscaped\x26lt;/b\x26gt;'}]}, {xtype:'bpcComboBox', fieldLabel:'BPC Combobox', queryMode:'local', displayField:'name', valueField:'abbr', store:[{abbr:'AL', name:'\x3cb\x3efett\x3c/b\x3e'}, {abbr:'AK', name:'\x3ci\x3eAlaska\x3c/i\x3e'}, 
{abbr:'AZ', name:'\x26lt;b\x26gt;fettEscaped\x26lt;/b\x26gt;'}]}, {xtype:'bpcTextField', fieldLabel:'Icon in emptyText', emptyText:'empty', emptyIconCls:'x-fal fa-save', plugins:[{ptype:'bpcInputField'}]}, {xtype:'bpcComboBox', fieldLabel:'Icon in emptyText', emptyText:'empty', emptyIconCls:'x-fal fa-save', plugins:[{ptype:'bpcInputField'}]}]});
Ext.define('demo.BpcJsonField', {extend:'Ext.panel.Panel', alias:'widget.demoBpcJsonField', title:'BPC JSON Field', layout:{type:'vbox', align:'stretch'}, items:[{xtype:'bpcJsonField', value:{Vorname:'Max', Nachname:'Mustermann'}}]});
Ext.define('demo.CenterMessageCmp', {extend:'Ext.panel.Panel', alias:'widget.demoCenterMessageCmp', title:'Center Message Component', layout:{type:'fit'}, items:[{xtype:'bpcCenterMessageCmp', message:'This Message Should Be Centered!', messageIconCls:'x-fal fa-fire'}]});
Ext.define('demo.DateRangeField', {extend:'Ext.panel.Panel', alias:'widget.demoDateRangeField', title:'DateRangeField Ausprägungen', layout:{type:'vbox'}, scrollable:true, defaults:{xtype:'bpcDateRangeField', labelWidth:400, width:600}, items:[{fieldLabel:'Standard'}, {fieldLabel:'Fester Zeitraum mit Defaultwerten für den Picker', absolute:true, relative:false, absoluteDefaultStartValue:new Date(2010, 0, 1), absoluteDefaultEndValue:new Date(2011, 11, 31), absoluteModeStartEnd:true, absoluteModeStart:false, 
absoluteModeEnd:false, absoluteModeAt:false}, {fieldLabel:'Fester Zeitraum mit Tagespicker', absolute:true, relative:false, absoluteDefaultStartValue:new Date(2020, 0, 1), absoluteModeStartEnd:false, absoluteModeStart:false, absoluteModeEnd:false, absoluteModeAt:true}, {fieldLabel:'Fester Zeitraum mit von/bis', absolute:true, relative:false, absoluteModeStartEnd:false, absoluteModeStart:true, absoluteModeEnd:true, absoluteModeAt:false}, {fieldLabel:'Relativer Zeitraum mit von/bis', absolute:false, 
relative:true, relativeModeStartEnd:false, relativeModeStart:true, relativeModeEnd:true, relativeShortCuts:false}, {fieldLabel:'Relativer Zeitraum mit von-bis mit Defaultwerten für den Picker', absolute:false, relative:true, relativeDefaultStartValue:'now-2w', relativeDefaultEndValue:'now+3d', relativeModeStartEnd:true, relativeModeStart:false, relativeModeEnd:false, relativeShortCuts:false}, {fieldLabel:'Vordefinierter Wert fest', value:{mode:'absolute', start:new Date(2020, 0, 1), end:new Date(2020, 
0, 10)}}, {fieldLabel:'Vordefinierter Wert gleitend', value:{mode:'relative', start:'now-5d/d', end:'now+1w'}}, {fieldLabel:'Vordefinierter Wert gleitend', value:{mode:'relative', start:'now/d-5d', end:'now/d+1w'}}, {fieldLabel:'Fester Zeitraum mit Zeitvorgabe (ohne Tag)', absolute:true, relative:false, absoluteDefaultStartTime:'11:11:11', absoluteDefaultEndTime:'22:22:22', absoluteModeStartEnd:true, absoluteModeStart:false, absoluteModeEnd:false, absoluteModeAt:false}]});
Ext.define('demo.DateRangePicker', {extend:'Ext.panel.Panel', alias:'widget.demoDateRangePicker', layout:{type:'vbox', align:'stretch'}, scrollable:true, items:[{xtype:'bpcDateRangePicker', title:'Ohne Konfiguration', iconCls:'x-fal fa-calendar-alt'}, {xtype:'bpcDateRangePicker', title:'Nur absolute Zeiträume', iconCls:'x-fal fa-calendar', relative:false}, {xtype:'bpcDateRangePicker', title:'Nur relative Zeiträume', iconCls:'x-fal fa-calendar-times', absolute:false}]});
Ext.define('demo.DemoGridWithJsonColumn', {extend:'Ext.grid.Panel', alias:'widget.demoGridWithJsonColumn', title:'Grid mit JSON Column', height:200, width:500, plugins:{cellediting:{clicksToEdit:1}}, store:{model:'BpcCommon.component.data.ObservableModel', data:[{text:'Edit Dummy Object', myJsonData:{foo:'bar', barrr:'fooo'}}, {text:'Edit Dummy Array', myJsonData:[{foo:'bar', barrr:'fooo'}]}]}, columns:[{text:'Text', dataIndex:'text', flex:1}, {xtype:'bpcSettingColumn', text:'My JSON Column', dataIndex:'myJsonData', 
flex:3, type:'json', codeEditorTitle:'My JSON Editor'}]});
Ext.define('demo.demoModuleInstanceSelector', {extend:'Ext.panel.Panel', alias:'widget.demoModuleInstanceSelector', title:'Module Instance Selector', items:[{xtype:'bpcModuleInstanceSelector', matchFieldWidth:false, baseModuleName:'monitor', fieldLabel:'Module'}]});
Ext.define('demo.demoMonthfield', {extend:'Ext.panel.Panel', alias:'widget.demoMonthField', title:'Month Field', items:[{xtype:'monthfield', fieldLabel:'Monat'}]});
Ext.define('demo.view.Component.DemoPromisePlaceholder', {extend:'Ext.panel.Panel', alias:'widget.demoPromisePlaceholder', title:'Promise Place Holder', initComponent:function() {
  var me = this;
  this.deferred = new Ext.Deferred();
  this.items = [{html:'Bei PromisePlaceholder geht es um asnychrone Abfragen. Die Komponente bleibe so lange im ' + 'Wartemodus(drehenden Kreischen), bis entweder resolve oder reject gedrückt wird.\x3cbr\x3e Bei resolve ' + 'wird der Promise erfüllt und gibt dann den vorgesehenen Wert zurück. (in diesem Fall einen Text)' + '\x3cbr\x3e Bei reject wird der Promise nicht erfüllt und es erscheint eine Fehlermeldung.\x3cbr\x3e\x3cbr\x3e\x3cbr\x3e', style:{'font-size':'34px'}}, {xtype:'button', text:'resolve', 
  x:400, handler:function() {
    me.deferred.resolve(me.getAsyncComponent());
  }}, {xtype:'button', text:'reject', x:410, handler:this.deferred.reject.bind(this.deferred, 'Promise rejected')}, {xtype:'bpcPromisePlaceholder', promise:this.deferred.promise, y:40}];
  this.callParent();
}, getAsyncComponent:function() {
  return {xtype:'box', html:'hallo Welt!', x:400, y:30, style:{'font-size':'18px'}};
}});
Ext.define('demo.view.Component.demoSettingPanel', {extend:'Ext.panel.Panel', alias:'widget.demoSettingPanel', items:[{xtype:'bpcSettingPanel', settings:BpcCommon.Api.getSettings('demo')}]});
Ext.define('demo.DemoShiftColumn', {extend:'Ext.grid.Panel', alias:'widget.demoShiftColumn', title:'Shift Column', layout:{type:'vbox', align:'stretch'}, scrollable:true, store:Ext.create('Ext.data.Store', {storeId:'simpsonsStore', fields:['Number'], data:[{Number:'1'}, {Number:'2'}, {Number:'3'}, {Number:'4'}, {Number:'5'}]}), columns:[{text:'Number', dataIndex:'Number'}, {text:'shiftColumn', dataIndex:'shiftColumn', xtype:'bpcCommonShiftColumn', width:200}], height:200, width:1000});
Ext.define('demo.view.components.DynamicFieldLabel', {extend:'Ext.panel.Panel', alias:'widget.demoDynamicFieldLabel', title:'Dynamic Field Label', defaults:{xtype:'textfield', plugins:{bpcDynamicFieldLabel:{labelOffset:5}}}, items:[{fieldLabel:'Foo'}, {fieldLabel:'Foo oo'}, {fieldLabel:'Foo oo oo'}, {fieldLabel:'Foo oo oo oo'}, {fieldLabel:'Foo', plugins:{bpcDynamicFieldLabel:{labelOffset:15}}}, {fieldLabel:'Foo oo', plugins:{bpcDynamicFieldLabel:{labelOffset:15}}}, {fieldLabel:'Foo oo oo', plugins:{bpcDynamicFieldLabel:{labelOffset:15}}}, 
{fieldLabel:'Foo oo oo oo', plugins:{bpcDynamicFieldLabel:{labelOffset:15}}}, {fieldLabel:'Foo', plugins:[]}, {fieldLabel:'Foo oo', plugins:[]}, {fieldLabel:'Foo oo oo', plugins:[]}, {fieldLabel:'Foo oo oo oo', plugins:[]}]});
Ext.define('demo.view.components.EditableGrid', {extend:'Ext.Panel', alias:'widget.demoEditableGrid', layout:'fit', title:'Editierbares Grid', items:[{xtype:'bpcEditableGrid', columns:[{header:'Name', dataIndex:'name', editor:'textfield'}, {header:'Email', dataIndex:'email', flex:1, editor:{xtype:'textfield', allowBlank:false}}, {header:'Phone', dataIndex:'phone'}], store:{fields:['name', 'email', 'phone'], data:[{name:'Lisa', email:'lisa@simpsons.com', phone:'555-111-1224'}, {name:'Bart', email:'bart@simpsons.com', 
phone:'555-222-1234'}, {name:'Homer', email:'homer@simpsons.com', phone:'555-222-1244'}, {name:'Marge', email:'marge@simpsons.com', phone:'555-222-1254'}]}}]});
Ext.define('demo.DemoEditors', {extend:'Ext.tab.Panel', alias:'widget.demoEditors', title:'Editoren', items:[{title:'JSON', xtype:'bpcJsonField', value:{eins:1, zwei:2}}, {title:'JavaScript', xtype:'bpcJavascriptField', value:"alert('Hello World')"}, {title:'Groovy', xtype:'bpcGroovyField', value:'publishing {\n' + '    publications {\n' + '        maven(MavenPublication) {\n' + '            artifactId \x3d bpcPrefix + packageName\n' + "            artifact('build/' + bpcPrefix + packageName +'.war') {\n" + 
"                extension 'war'\n" + '            }\n' + '        }\n' + '    }\n' + '    repositories {\n' + '        maven {\n' + "            name 'VirtimoMavenArtifactory'\n" + "            url version.endsWith('SNAPSHOT') ? snapshotsRepoUrl : releasesRepoUrl\n" + '            credentials {\n' + '                username \x3d deployRepoUsername\n' + '                password \x3d deployRepoPassword\n' + '            }\n' + '        }\n' + '    }\n' + '}\n' + '\n' + "defaultTasks 'run'\n" + '\n' + 
'//init some properties\n' + 'project.ext {\n' + '  gitBranch  \x3d "unknown"\n' + '  gitCommit \x3d "unknown"\n' + '  gitDirtyState \x3d "unknown"\n' + '  buildId \x3d "unknown"\n' + '  buildTimestamp \x3d new Date().format("yyyy-MM-dd\'T\'HH:mm:ssZ")\n' + '}'}, {title:'CSS', html:'Coming soon'}]});
Ext.define('demo.view.components.FieldValidator', {extend:'Ext.tab.Panel', alias:'widget.demoFieldValidator', title:'Field Validator', defaults:{layout:{type:'vbox'}, bodyPadding:10, items:[{xtype:'bpcTextField', allowBlank:false, fieldLabel:'Mandatory text field', msgTarget:'side'}, {xtype:'bpcNumberField', value:42, minValue:23, maxValue:23, fieldLabel:'Number field which only accepts 23', msgTarget:'side'}, {xtype:'button', text:'Simple button'}, {xtype:'button', text:'Button linked to validation', 
enableOnValidForm:true}]}, items:[{xtype:'panel', title:'Injected in Toolbar', tbar:[], plugins:{bpcFieldValidator:{autoInjectValidationButton:true}}}, {xtype:'panel', title:'Custom btn via default itemId', tbar:[{xtype:'button', iconCls:'x-fal fa-fire', text:'this text will be overridden by the plugin', itemId:'formChecker'}], plugins:{bpcFieldValidator:{markInvalidOnHighlight:true, validationButtonSelector:'#formChecker'}}}]});
Ext.define('demo.view.main.DemoArea', {extend:'Ext.panel.Panel', alias:'widget.demoDemoArea', bodyPadding:10, items:[{xtype:'bpcCenterMessageCmp', html:'\x3ci class\x3d"fal fa-child fa-5x fa-fw"\x3e\x3c/i\x3e\x3cbr\x3e\x3cspan\x3eWählen Sie eine Demo aus\x3c/span\x3e'}]});
Ext.define('demo.view.main.DemoContainer', {extend:'Ext.Panel', alias:'widget.demoDemoContainer', demoConfig:{}, dockedItems:[{xtype:'demoSourceCodeViewer', width:500, dock:'right', resizable:true, collapsible:true, collapseDirection:'right'}], layout:'fit', stateful:true, stateId:'demoContainer', initComponent:function() {
  var me = this;
  var route = me.record.get('text');
  Ext.apply(me.demoConfig, {routePath:route});
  me.items = [me.demoConfig];
  me.callParent();
  var codeViewer = me.down('demoSourceCodeViewer');
  var demoFiles = me.demoConfig.files;
  var errMessage = 'Code preview nicht verfügbar';
  if (!Ext.isArray(demoFiles) || demoFiles.length === 0) {
    codeViewer.add({xtype:'bpcCenterMessageCmp', html:errMessage});
    codeViewer.collapse();
  }
  Ext.Array.each(demoFiles, function(file) {
    Ext.Ajax.request({url:'bpc-fe-demo/resources/src/' + file, success:function(response) {
      codeViewer.add({title:file.split('/').pop(), xtype:'bpcJavascriptField', value:response.responseText});
      codeViewer.expand();
    }, failure:function() {
      codeViewer.add({xtype:'bpcCenterMessageCmp', html:errMessage});
      codeViewer.collapse();
    }});
  });
}});
Ext.define('demo.view.main.OverviewPanel', {extend:'Ext.Panel', alias:'widget.demoOverviewPanel', controller:'demoOverviewPanelController', bodyPadding:5, layout:{type:'hbox', align:'stretch'}, items:[{xtype:'bpcDemoTree', flex:1}, {xtype:'bpcSplitter'}, {xtype:'demoDemoArea', layout:'card', flex:3}]});
Ext.define('demo.view.main.OverviewPanelController', {extend:'Ext.app.ViewController', alias:'controller.demoOverviewPanelController', control:{bpcDemoTree:{select:'onDemoSelect'}}, onDemoSelect:function(eventSource, demoRecord) {
  try {
    if (demoRecord.get('demoConfig')) {
      var target = this.getView().down('demoDemoArea');
      if (!demoRecord.demoViewer) {
        var newCmp = target.add({xtype:'demoDemoContainer', demoConfig:demoRecord.get('demoConfig'), record:demoRecord});
        demoRecord.demoViewer = target.add(newCmp);
      }
      target.setActiveItem(demoRecord.demoViewer);
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onDemoSelect', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('demo.view.main.SourceCodeViewer', {extend:'Ext.tab.Panel', alias:'widget.demoSourceCodeViewer', title:'Source Code', iconCls:'x-fal fa-code', defaults:{iconCls:'x-fal fa-file-code'}});
Ext.define('demo.view.main.Tree', {extend:'Ext.tree.Panel', alias:'widget.bpcDemoTree', columns:[{xtype:'treecolumn', dataIndex:'text', flex:1, renderer:BpcCommon.Api.getTranslation}], store:{autoLoad:true, proxy:{type:'ajax', url:'bpc-fe-demo/resources/demoTree.json'}}, dockedItems:[{xtype:'demoPluginHook', dock:'bottom'}]});
Ext.define('demo.view.theme.store.Files', {extend:'Ext.data.TreeStore', alias:'store.files', rootData:{text:'Ext JS', expanded:true, children:[{text:'app', children:[{leaf:true, text:'Application.js'}]}, {text:'button', expanded:true, children:[{leaf:true, text:'Button.js'}, {leaf:true, text:'Cycle.js'}, {leaf:true, text:'Split.js'}]}, {text:'container', children:[{leaf:true, text:'ButtonGroup.js'}, {leaf:true, text:'Container.js'}, {leaf:true, text:'Viewport.js'}]}, {text:'core', children:[{text:'dom', 
children:[{leaf:true, text:'Element.form.js'}, {leaf:true, text:'Element.static-more.js'}]}]}, {text:'dd', children:[{leaf:true, text:'DD.js'}, {leaf:true, text:'DDProxy.js'}, {leaf:true, text:'DDTarget.js'}, {leaf:true, text:'DragDrop.js'}, {leaf:true, text:'DragDropManager.js'}, {leaf:true, text:'DragSource.js'}, {leaf:true, text:'DragTracker.js'}, {leaf:true, text:'DragZone.js'}, {leaf:true, text:'DragTarget.js'}, {leaf:true, text:'DragZone.js'}, {leaf:true, text:'Registry.js'}, {leaf:true, text:'ScrollManager.js'}, 
{leaf:true, text:'StatusProxy.js'}]}, {text:'core', children:[{leaf:true, text:'Element.alignment.js'}, {leaf:true, text:'Element.anim.js'}, {leaf:true, text:'Element.dd.js'}, {leaf:true, text:'Element.fx.js'}, {leaf:true, text:'Element.js'}, {leaf:true, text:'Element.position.js'}, {leaf:true, text:'Element.scroll.js'}, {leaf:true, text:'Element.style.js'}, {leaf:true, text:'Element.traversal.js'}, {leaf:true, text:'Helper.js'}, {leaf:true, text:'Query.js'}]}, {leaf:true, text:'Action.js'}, {leaf:true, 
text:'Component.js'}, {leaf:true, text:'Editor.js'}, {leaf:true, text:'Img.js'}, {leaf:true, text:'Layer.js'}, {leaf:true, text:'LoadMask.js'}, {leaf:true, text:'ProgressBar.js'}, {leaf:true, text:'Shadow.js'}, {leaf:true, text:'ShadowPool.js'}, {leaf:true, text:'ZIndexManager.js'}]}, constructor:function(config) {
  config = Ext.apply({root:Ext.clone(this.rootData)}, config);
  this.callParent([config]);
}});
Ext.define('demo.view.theme.Main', {extend:'Ext.panel.Panel', alias:'widget.demoThemeMain', iconCls:'x-fal fa-pencil', title:'BPC Theme', itmeId:'demoThemeMain', controller:'demoThemeMainController', viewModel:{data:{notificationType:'INFO', notificationToast:false, measurement:{no:'data'}, disabled:false}}, layout:{type:'vbox', align:'stretch'}, scrollable:true, defaultButtonSet:[{text:'Primary', ui:'primary'}, {text:'P pressed', ui:'primary', enableToggle:true, pressed:true}, {text:'Secondary', 
ui:'secondary'}, {text:'S pressed', ui:'secondary', enableToggle:true, pressed:true}, {text:'Destructive', ui:'destructive', iconCls:'x-fal fa-trash-alt'}, {text:'Destructive Secondary', iconCls:'x-fal fa-trash-alt', ui:'destructiveSecondary'}, {text:'Default'}, {text:'pressed', enableToggle:true, pressed:true}, {iconCls:BpcCommon.Icons.FAV}, {iconCls:BpcCommon.Icons.FAV, text:'With Icon'}, {xtype:'splitbutton', iconCls:BpcCommon.Icons.FAV, text:'Split Button', menu:{items:[{text:'Item 1'}, {text:'Item 2'}]}}].map(function(btn) {
  return Ext.applyIf(btn, {xtype:'button', bind:{disabled:'{disabled}', tooltip:'{disabled ? "Buttons are disabled" : "Button tooltip"}'}});
}), bbar:[{xtype:'checkbox', boxLabel:'Disabled', bind:'{disabled}'}], initComponent:function() {
  var me = this;
  me.items = [{title:'Panels Demo', xtype:'panel', header:false, scrollable:true, layout:{type:'hbox', align:'stretch'}, defaults:{margin:8, overflowY:'scroll', width:200, height:200}, items:[{xtype:'panel', title:'Panel framed', frame:true, items:[{html:'Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.'}]}, 
  {xtype:'panel', title:'Collapsible', collapsible:true, frame:true, items:[{html:'Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.'}]}, 
  {xtype:'panel', title:'Panel Masked', itemId:'maskedPanel', frame:true, items:[{html:'Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.'}], 
  buttons:[{text:'load...', handler:'showLoadingMask'}]}, {xtype:'panel', title:'Panel NOT Framed', frame:false, items:[{html:'Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.'}]}, 
  {xtype:'panel', layout:'center', title:'Collapsible', collapsible:true, overflowY:'scroll', frame:false, width:200, height:200, items:[{html:'Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.'}]}]}, 
  {title:'Panel Layouts', xtype:'panel', header:false, scrollable:true, layout:{type:'hbox', align:'stretch'}, defaults:{margin:8}, items:[{xtype:'panel', width:200, height:300, layout:{type:'accordion', titleCollapse:false, animate:false, activeOnTop:false}, items:[{title:'Accordion 1', html:'Panel content 1!'}, {title:'Accordion 2', overflowY:'scroll', items:[{xtype:'panel', title:'Panel in accordion', frame:true, html:'Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.'}]}, 
  {title:'Viel Text', overflowY:'scroll', html:'Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.'}]}, 
  {xtype:'tabpanel', width:200, height:300, activeTab:0, items:[{title:'Tab 1', items:[{xtype:'panel', title:'Panel in a Tab', frame:true, html:'Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.'}]}, 
  {title:'Viel Text', overflowY:'auto', html:'Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.'}]}, 
  {xtype:'tabpanel', width:200, height:300, activeTab:0, items:[{title:'Tab 1', closable:true, html:'Scroller in Tabbar'}, {title:'Tab 2', closable:true, html:'closable tab'}, {title:'Tab 3', closable:true, html:'closable tab'}, {title:'Tab 4', closable:true, html:'Another one'}, {title:'Tab 5', closable:true, html:'A simple tab'}, {title:'Tab 6', closable:true, html:'Another one'}]}, {xtype:'panel', width:400, height:300, layout:'border', defaults:{collapsible:true, split:true, bodyPadding:10}, 
  items:[{title:'Footer', region:'south', height:100, minHeight:75, maxHeight:100, html:'\x3cp\x3eFooter content\x3c/p\x3e'}, {title:'Navigation', region:'west', floatable:false, margin:'5 0 0 0', width:125, minWidth:100, maxWidth:250, html:'\x3cp\x3eSecondary content like navigation links could go here\x3c/p\x3e'}, {title:'Main Content', collapsible:false, region:'center', margin:'5 0 0 0', html:'\x3ch2\x3eMain Page\x3c/h2\x3e\x3cp\x3eThis is where the main content would go\x3c/p\x3e'}]}]}, {title:'Toolbars \x26 Buttons', 
  xtype:'panel', scrollable:true, layout:{type:'vbox', align:'stretch'}, defaults:{margin:8}, items:[{title:'Buttons in Toolbars tbar / bar + as default Panel Content', xtype:'panel', flex:1, tbar:me.defaultButtonSet, bbar:me.defaultButtonSet, items:me.defaultButtonSet}, {title:'Breadcrumbs', xtype:'panel', flex:1, overflowHandler:'scroller', tbar:[{xtype:'breadcrumb', showIcons:true, store:{type:'files'}, items:[{xtype:'component', html:'Split buttons:', style:{'margin-left':'10px', 'margin-right':'10px'}}]}], 
  bbar:[{xtype:'breadcrumb', showIcons:true, useSplitButtons:false, store:{type:'files'}, items:[{xtype:'component', html:'Normal buttons:', style:{'margin-left':'10px', 'margin-right':'10px'}}]}]}]}, {title:'All the Buttons', xtype:'panel', header:false, scrollable:true, layout:{type:'vbox', align:'stretch'}, defaults:{margin:8}, items:[{title:'Buttons', xtype:'panel', frame:true, items:[{xtype:'container', layout:{type:'table', columns:4, tdAttrs:{style:'padding: 5px 10px;'}}, defaults:{bind:{disabled:'{disabled}', 
  tooltip:'{disabled ? "Buttons are disabled" : "Button tooltip"}'}}, items:[{xtype:'component', html:'Text Only', bind:null}, {xtype:'button', text:'Small'}, {xtype:'button', text:'Medium', scale:'medium'}, {xtype:'button', text:'Large', scale:'large'}, {xtype:'component', html:'Icon Only', bind:null}, {iconCls:'x-fal fa-paper-plane', xtype:'button'}, {xtype:'button', iconCls:'x-fal fa-paper-plane', scale:'medium'}, {xtype:'button', iconCls:'x-fal fa-paper-plane', scale:'large'}, {xtype:'component', 
  html:'Icon and Text (left)', bind:null}, {xtype:'button', iconCls:'x-fal fa-paper-plane', text:'Small'}, {xtype:'button', iconCls:'x-fal fa-paper-plane', text:'Medium', scale:'medium'}, {xtype:'button', iconCls:'x-fal fa-paper-plane', text:'Large', scale:'large'}, {xtype:'component', html:'Secondary', bind:null}, {xtype:'button', ui:'secondary', iconCls:'x-fal fa-cat', text:'Small'}, {xtype:'button', ui:'secondary', iconCls:'x-fal fa-cat', text:'Medium', scale:'medium'}, {xtype:'button', ui:'secondary', 
  iconCls:'x-fal fa-cat', text:'Large', scale:'large'}, {xtype:'component', html:'Destructive', bind:null}, {xtype:'button', ui:'destructive', iconCls:'x-fal fa-trash-alt', text:'Small', scale:'small'}, {xtype:'button', ui:'destructive', iconCls:'x-fal fa-trash-alt', text:'Medium', scale:'medium'}, {xtype:'button', ui:'destructive', iconCls:'x-fal fa-trash-alt', text:'Large', scale:'large'}, {xtype:'component', html:'Destructive Secondary', bind:null}, {xtype:'button', ui:'destructiveSecondary', 
  iconCls:'x-fal fa-trash-alt', text:'Small', scale:'small'}, {xtype:'button', ui:'destructiveSecondary', iconCls:'x-fal fa-trash-alt', text:'Medium', scale:'medium'}, {xtype:'button', ui:'destructiveSecondary', iconCls:'x-fal fa-trash-alt', text:'Large', scale:'large'}]}], buttons:me.defaultButtonSet}, {title:'Menu \x26 Split Buttons', xtype:'panel', frame:true, layout:{type:'table', columns:4, tdAttrs:{style:'padding: 5px 10px;'}}, defaults:{menu:[{text:'Menu Item 1'}, {text:'Menu Item 2'}, {text:'Menu Item 3'}]}, 
  items:[{xtype:'component', html:'Text Only'}, {xtype:'button', text:'Small'}, {xtype:'button', text:'Medium', scale:'medium'}, {xtype:'button', text:'Large', scale:'large'}, {xtype:'component', html:'Icon Only'}, {iconCls:'x-fal fa-home', xtype:'button'}, {xtype:'button', iconCls:'x-fal fa-home', scale:'medium'}, {xtype:'button', iconCls:'x-fal fa-home', scale:'large'}, {xtype:'component', html:'Icon and Text (left)'}, {xtype:'button', iconCls:'x-fal fa-home', text:'Small'}, {xtype:'button', iconCls:'x-fal fa-home', 
  text:'Medium', scale:'medium'}, {xtype:'button', iconCls:'x-fal fa-home', text:'Large', scale:'large'}, {xtype:'component', html:'Split Text Only', bind:null}, {xtype:'splitbutton', text:'Small'}, {xtype:'splitbutton', text:'Medium', scale:'medium'}, {xtype:'splitbutton', text:'Large', scale:'large'}, {xtype:'component', html:'Split Icon Only (toggle)', bind:null}, {xtype:'splitbutton', iconCls:'x-fal fa-home', enableToggle:true}, {xtype:'splitbutton', iconCls:'x-fal fa-home', scale:'medium', enableToggle:true}, 
  {xtype:'splitbutton', iconCls:'x-fal fa-home', scale:'large', enableToggle:true}, {xtype:'component', html:'Split Icon and Text', bind:null}, {xtype:'splitbutton', iconCls:'x-fal fa-home', text:'Small'}, {xtype:'splitbutton', iconCls:'x-fal fa-home', text:'Medium', scale:'medium'}, {xtype:'splitbutton', iconCls:'x-fal fa-home', text:'Large', scale:'large'}]}]}, {title:'More Buttons', xtype:'panel', header:false, scrollable:true, layout:{type:'vbox', align:'stretch'}, defaults:{margin:8}, items:[{title:'Button Groups', 
  xtype:'panel', layout:'column', cls:'segmented-buttons', padding:10, frame:true, defaultType:'fieldcontainer', defaults:{labelAlign:'top', margin:'20'}, items:[{fieldLabel:'Toggle Group', columnWidth:0.25, items:[{xtype:'segmentedbutton', vertical:true, bind:{disabled:'{disabled}'}, items:[{text:'Option One'}, {text:'Option Two', pressed:true}, {text:'Option Three'}]}]}, {fieldLabel:'Multiple Toggle', columnWidth:0.25, items:[{xtype:'segmentedbutton', vertical:true, allowMultiple:true, bind:{disabled:'{disabled}'}, 
  items:[{text:'Option One', pressed:true}, {text:'Option Two'}, {text:'Option Three', pressed:true}]}]}, {fieldLabel:'No Toggle', columnWidth:0.25, items:[{xtype:'segmentedbutton', vertical:true, allowToggle:false, bind:{disabled:'{disabled}'}, items:[{text:'Option One'}, {text:'Option Two'}, {text:'Option Three'}]}]}, {fieldLabel:'Icons/Arrows', columnWidth:0.25, items:[{xtype:'segmentedbutton', vertical:true, allowToggle:false, bind:{disabled:'{disabled}'}, items:[{iconCls:BpcCommon.Icons.ACCESS_DENIED, 
  text:'Button'}, {text:'Menu Button', menu:[{text:'Menu Item 1'}, {text:'Menu Item 2'}, {text:'Menu Item 3'}]}, {xtype:'splitbutton', text:'Split Button', menu:[{text:'Menu Item 1'}, {text:'Menu Item 2'}, {text:'Menu Item 3'}]}]}]}]}, {xtype:'panel', title:'Buttons in Panel Header', frame:true, header:{items:me.defaultButtonSet}, layout:'hbox', items:me.defaultButtonSet}, {xtype:'panel', ui:'hidden-header-items', title:'ui: hidden-header-items', frame:true, header:{items:me.defaultButtonSet}, layout:'hbox', 
  items:me.defaultButtonSet}]}, {title:'Forms and Grids', xtype:'panel', header:false, scrollable:true, layout:{type:'hbox', align:'stretch'}, defaults:{margin:8}, items:[{xtype:'fieldset', collapsible:true, defaults:{anchor:'100%'}, title:'Notifications Test', itemId:'notificationFieldSet', items:[{xtype:'textfield', fieldLabel:'Notification Text', bind:'{notificationText}'}, {xtype:'radiogroup', fieldLabel:'Typ', columns:4, bind:'{notificationType}', items:[{boxLabel:'Info', name:'notificationType', 
  inputValue:'INFO'}, {boxLabel:'Warnung', name:'notificationType', inputValue:'WARNING'}, {boxLabel:'Fehler', name:'notificationType', inputValue:'ERROR'}, {boxLabel:'Frage', name:'notificationType', inputValue:'QUESTION'}]}, {xtype:'checkboxgroup', fieldLabel:'Optionen', columns:4, items:[{boxLabel:'PopUp', bind:'{notificationPopUp}'}, {boxLabel:'Toast', bind:'{notificationToast}'}, {boxLabel:'Silent', bind:'{notificationSilent}'}]}, {xtype:'radiogroup', fieldLabel:'Toast Ziel', columns:4, bind:{value:'{notificationToastTarget}', 
  disabled:'{!notificationToast}'}, items:[{boxLabel:'Global', name:'notificationToastTarget', inputValue:'global', checked:true}, {boxLabel:'Modul', name:'notificationToastTarget', inputValue:'module'}, {boxLabel:'Fieldset', name:'notificationToastTarget', inputValue:'fieldset'}]}, {xtype:'button', iconCls:'x-fal fa-paper-plane', text:'Senden', handler:'sendNotification'}]}, {xtype:'panel', title:'Form Validation Demo', frame:true, width:320, defaultType:'textfield', items:[{allowBlank:false, fieldLabel:'User ID', 
  name:'user', emptyText:'user id', msgTarget:'under'}, {allowBlank:false, fieldLabel:'Password', name:'pass', emptyText:'password', inputType:'password', msgTarget:'under'}, {xtype:'datefield', allowBlank:false, fieldLabel:'Datum', msgTarget:'under'}], buttons:[{text:'Login'}], defaults:{anchor:'100%', labelWidth:100}}, {xtype:'panel', layout:'center', title:'Grid Demo', frame:true, width:500, items:[{xtype:'gridpanel', store:{fields:['name', 'email', 'phone'], data:[{name:'Lisa', email:'lisa@simpsons.com', 
  phone:'555-111-1224'}, {name:'Bart', email:'bart@simpsons.com', phone:'555-222-1234'}, {name:'Homer', email:'homer@simpsons.com', phone:'555-222-1244'}, {name:'Marge', email:'marge@simpsons.com', phone:'555-222-1254'}]}, columns:[{header:'Name', dataIndex:'name'}, {header:'Email', dataIndex:'email', flex:1}], height:200, width:300}], buttons:[{iconCls:'x-fal fa-th', text:'cell edit demo', handler:'openGridCellEditor'}, {iconCls:'x-fal fa-grip-lines', text:'row edit demo', handler:'openGridRowEditor'}, 
  {iconCls:'x-fal fa-grip-lines', text:'Json Editor Column', handler:'openGridJsonEditorColumn'}]}, {xtype:'panel', title:'Form Fields', frame:true, width:320, items:[{xtype:'bpcComboBox', fieldLabel:'Choose State', store:Ext.create('Ext.data.Store', {fields:['abbr', 'name'], data:[{'abbr':'AL', 'name':'Alabama'}, {'abbr':'AK', 'name':'Alaska'}, {'abbr':'null', 'name':null}, {'abbr':'AZ', 'name':'Arizona'}]}), queryMode:'local', displayField:'name', valueField:'abbr'}, {xtype:'bpcDragDropTagField', 
  fieldLabel:'Choose Sequence', store:['First', 'Second', 'Third', 'Fourth']}], buttons:[{text:'Login'}], defaults:{anchor:'100%', labelWidth:100}}]}, {title:'All the Trees', xtype:'panel', header:false, scrollable:true, layout:{type:'table', columns:3, tdAttrs:{style:'padding: 10px;'}}, defaults:{margin:8, xtype:'treepanel', width:300, height:200, rootVisible:false, store:{type:'files'}}, items:[{title:'Tree'}, {title:'Tree with No Lines', lines:false}, {title:'Tree with Arrows', useArrows:true}]}];
  me.callParent();
}});
Ext.define('demo.view.theme.MainController', {extend:'Ext.app.ViewController', alias:'controller.demoThemeMainController', init:function() {
  this.initGridDataStore();
}, sendNotification:function() {
  var vm = this.getViewModel();
  var notificationText = Ext.util.Format.date(new Date(), 'H:i:s') + ' ' + vm.get('notificationText');
  var toastTarget = undefined;
  if (vm.get('notificationToastTarget') && vm.get('notificationToastTarget').notificationToastTarget === 'module') {
    toastTarget = this.getView();
  } else if (vm.get('notificationToastTarget') && vm.get('notificationToastTarget').notificationToastTarget === 'fieldset') {
    toastTarget = this.getView().down('#notificationFieldSet');
  }
  BpcCommon.Api.showNotification({text:notificationText, type:vm.get('notificationType').notificationType, popUp:vm.get('notificationPopUp'), toast:vm.get('notificationToast'), toastTarget:toastTarget, silent:vm.get('notificationSilent')});
}, initGridDataStore:function() {
  Ext.create('Ext.data.Store', {storeId:'simpsonsStore', fields:['name', 'email', 'phone'], data:[{name:'Lisa', email:'lisa@simpsons.com', phone:'555-111-1224'}, {name:'Bart', email:'bart@simpsons.com', phone:'555-222-1234'}, {name:'Homer', email:'homer@simpsons.com', phone:'555-222-1244'}, {name:'Marge', email:'marge@simpsons.com', phone:'555-222-1254'}]});
}, showLoadingMask:function() {
  var maskTarget = this.getView().down('#maskedPanel');
  (new Ext.LoadMask({msg:'Please wait...', target:maskTarget})).show();
}, openGridCellEditor:function(button) {
  if (!button.modiwin) {
    button.modiwin = this.createCellEditor();
  }
  button.modiwin.on('close', function() {
    button.modiwin.destroy();
    button.modiwin = null;
  });
  button.modiwin.show();
}, openGridRowEditor:function(button) {
  if (!button.modiwin) {
    button.modiwin = this.createRowEditor();
  }
  button.modiwin.on('close', function() {
    button.modiwin.destroy();
    button.modiwin = null;
  });
  button.modiwin.show();
}, createCellEditor:function() {
  return Ext.create('Ext.window.Window', {title:'Cell Editor Demo', cls:'grid-cell-edit-demo', items:[Ext.create('Ext.grid.Panel', {store:Ext.data.StoreManager.lookup('simpsonsStore'), columns:[{header:'Name', dataIndex:'name', editor:'textfield'}, {header:'Email', dataIndex:'email', flex:1, editor:{xtype:'textfield', allowBlank:false}}, {header:'Phone', dataIndex:'phone'}], selModel:'cellmodel', plugins:{ptype:'cellediting', clicksToEdit:1}, height:200, width:500})]});
}, createRowEditor:function() {
  return Ext.create('Ext.window.Window', {title:'Row Editor Demo', cls:'grid-row-edit-demo', items:[Ext.create('Ext.grid.Panel', {store:Ext.data.StoreManager.lookup('simpsonsStore'), columns:[{header:'Name', dataIndex:'name', editor:'textfield'}, {header:'Email', dataIndex:'email', flex:1, editor:{xtype:'textfield', allowBlank:false}}, {header:'Phone', dataIndex:'phone'}], selModel:'rowmodel', plugins:{rowediting:{clicksToEdit:1}}, height:200, width:500})]});
}, showNext:function() {
  this.doCardNavigation(1);
}, showPrevious:function() {
  this.doCardNavigation(-1);
}, doCardNavigation:function(incr) {
  var me = this.getView();
  var l = me.getLayout();
  var i = l.activeItem.id.split('card-')[1];
  var next = parseInt(i, 10) + incr;
  l.setActiveItem(next);
  me.down('#card-prev').setDisabled(next === 0);
  me.down('#card-next').setDisabled(next === 2);
}, openGridJsonEditorColumn:function() {
  Ext.create('Ext.window.Window', {title:'Grid with JSON Editor Column Demo', cls:'grid-row-edit-demo', items:[{xtype:'demoGridWithJsonColumn'}]}).show();
}});
