/**
 * Created by andre on 2019-01-11.
 */
Ext.define("demo.plugin.toolbar.Plugin", {
   extend : "Ext.toolbar.Toolbar",
   alias  : "widget.demoToolbarPlugin",

   initComponent : function () {
      let configureIconCls = "x-fal fa-question";

      /* read the config */
      if (Ext.isDefined(this.pluginConfiguration) && Ext.isDefined(this.pluginConfiguration.configuration.iconCls)) {
         configureIconCls = this.pluginConfiguration.configuration.iconCls;
      }

      this.items = [
         {
            xtype   : "button",
            itemId  : "pluginToolbarButton",
            iconCls : configureIconCls,
            handler : (btn) => {
               btn.up("demoToolbarPlugin").down("#pluginToolbarTextfield").setValue((new Date()).toISOString());
            }
         }, {
            xtype      : "textfield",
            fieldLabel : "Demo",
            itemId     : "pluginToolbarTextfield",
            plugins    : ["bpcDynamicFieldLabel"],
         }
      ];

      this.callParent();
   }

});