/**
 * Created by andre on 16.10.18.
 */
Ext.define("demo.DateRangeField", {
   extend : "Ext.panel.Panel",
   alias  : "widget.demoDateRangeField",
    
   title : "DateRangeField Ausprägungen",
    
   layout : {
      type : "vbox"
      // align: "stretch"
   },
    
   scrollable : true,
    
   defaults : {
      xtype      : "bpcDateRangeField",
      labelWidth : 400,
      width      : 600
   },
    
   items : [
      {
         fieldLabel : "Standard"
      },
      {
         fieldLabel                : "Fester Zeitraum mit Defaultwerten für den Picker",
         absolute                  : true,
         relative                  : false,
         absoluteDefaultStartValue : new Date(2010, 0, 1),
         absoluteDefaultEndValue   : new Date(2011, 11, 31),
         absoluteModeStartEnd      : true,
         absoluteModeStart         : false,
         absoluteModeEnd           : false,
         absoluteModeAt            : false
      },
      {
         fieldLabel                : "Fester Zeitraum mit Tagespicker",
         absolute                  : true,
         relative                  : false,
         absoluteDefaultStartValue : new Date(2020, 0, 1),
         absoluteModeStartEnd      : false,
         absoluteModeStart         : false,
         absoluteModeEnd           : false,
         absoluteModeAt            : true
      },
      {
         fieldLabel           : "Fester Zeitraum mit von/bis",
         absolute             : true,
         relative             : false,
         absoluteModeStartEnd : false,
         absoluteModeStart    : true,
         absoluteModeEnd      : true,
         absoluteModeAt       : false
      },
      {
         fieldLabel           : "Relativer Zeitraum mit von/bis",
         absolute             : false,
         relative             : true,
         relativeModeStartEnd : false,
         relativeModeStart    : true,
         relativeModeEnd      : true,
         relativeShortCuts    : false
      },
      {
         fieldLabel                : "Relativer Zeitraum mit von-bis mit Defaultwerten für den Picker",
         absolute                  : false,
         relative                  : true,
         relativeDefaultStartValue : "now-2w",
         relativeDefaultEndValue   : "now+3d",
         relativeModeStartEnd      : true,
         relativeModeStart         : false,
         relativeModeEnd           : false,
         relativeShortCuts         : false
      },
      {
         fieldLabel : "Vordefinierter Wert fest",
         value      : {
            mode  : "absolute",
            start : new Date(2020, 0, 1),
            end   : new Date(2020, 0, 10)
         }
      },
      {
         fieldLabel : "Vordefinierter Wert gleitend",
         value      : {
            mode  : "relative",
            start : "now-5d/d",
            end   : "now+1w"
         }
      },
      {
         fieldLabel : "Vordefinierter Wert gleitend",
         value      : {
            mode  : "relative",
            start : "now/d-5d",
            end   : "now/d+1w"
         }
      },
      {
         fieldLabel               : "Fester Zeitraum mit Zeitvorgabe (ohne Tag)",
         absolute                 : true,
         relative                 : false,
         absoluteDefaultStartTime : "11:11:11",
         absoluteDefaultEndTime   : "22:22:22",
         absoluteModeStartEnd     : true,
         absoluteModeStart        : false,
         absoluteModeEnd          : false,
         absoluteModeAt           : false
      }
   ]
});