Ext.define("demo.DemoGridWithJsonColumn", {
   extend : "Ext.grid.Panel",
   alias  : "widget.demoGridWithJsonColumn",

   title   : "Grid mit JSON Column",
   height  : 200,
   width   : 500,
   plugins : {
      cellediting : {
         clicksToEdit : 1
      }
   },
   store : {
      model : "BpcCommon.component.data.ObservableModel",
      data  : [
         { text: "Edit Dummy Object", myJsonData: { foo: "bar", barrr: "fooo" } },
         { text: "Edit Dummy Array", myJsonData: [{ foo: "bar", barrr: "fooo" }] }
      ]
   },
   columns : [
      {
         text      : "Text",
         dataIndex : "text",
         flex      : 1
      },
      {
         xtype           : "bpcSettingColumn",
         text            : "My JSON Column",
         dataIndex       : "myJsonData",
         flex            : 3,
         type            : "json",
         codeEditorTitle : "My JSON Editor"
      }
   ]
});
