Ext.define("demo.view.Component.DemoPromisePlaceholder", {
   extend        : "Ext.panel.Panel",
   alias         : "widget.demoPromisePlaceholder",
   title         : "Promise Place Holder",
   initComponent : function () {

        
      const me = this;
        
      this.deferred = new Ext.Deferred();
        
      this.items = [
         {
            html : "Bei PromisePlaceholder geht es um asnychrone Abfragen. Die Komponente bleibe so lange im "
                    + "Wartemodus(drehenden Kreischen), bis entweder resolve oder reject gedrückt wird.<br> Bei resolve "
                    + "wird der Promise erfüllt und gibt dann den vorgesehenen Wert zurück. (in diesem Fall einen Text)"
                    + "<br> Bei reject wird der Promise nicht erfüllt und es erscheint eine Fehlermeldung.<br><br><br>",
            style : {
               "font-size" : "34px"
            }
         },
         {
            xtype   : "button",
            text    : "resolve",
            x       : 400,
            handler : function () {
               // this function resolves the promise with a new component
               me.deferred.resolve(me.getAsyncComponent());
            }
         },
         {
            xtype   : "button",
            text    : "reject",
            x       : 410,
            handler : this.deferred.reject.bind(this.deferred, "Promise rejected")
         },
         {
            xtype   : "bpcPromisePlaceholder",
            promise : this.deferred.promise,
            y       : 40
         }
      ];
      this.callParent();
   },
    
   getAsyncComponent : function () {
      return {
         xtype : "box",
         html  : "hallo Welt!",
         x     : 400,
         y     : 30,
         style : {
            "font-size" : "18px"
         }
      };
   }
});
