Ext.define("demo.view.components.DynamicFieldLabel", {
   extend : "Ext.panel.Panel",
   alias  : "widget.demoDynamicFieldLabel",
   title  : "Dynamic Field Label",
   
   defaults : {
      xtype   : "textfield",
      plugins : {
         bpcDynamicFieldLabel : {
            labelOffset : 5
         }
      }
   },
   
   items : [{
      fieldLabel : "Foo"
   }, {
      fieldLabel : "Foo oo"
   }, {
      fieldLabel : "Foo oo oo"
   }, {
      fieldLabel : "Foo oo oo oo"
   }, {
      fieldLabel : "Foo",
      plugins    : {
         bpcDynamicFieldLabel : {
            labelOffset : 15
         }
      }
   }, {
      fieldLabel : "Foo oo",
      plugins    : {
         bpcDynamicFieldLabel : {
            labelOffset : 15
         }
      }
   }, {
      fieldLabel : "Foo oo oo",
      plugins    : {
         bpcDynamicFieldLabel : {
            labelOffset : 15
         }
      }
   }, {
      fieldLabel : "Foo oo oo oo",
      plugins    : {
         bpcDynamicFieldLabel : {
            labelOffset : 15
         }
      }
   }, {
      fieldLabel : "Foo",
      plugins    : []
   }, {
      fieldLabel : "Foo oo",
      plugins    : []
   }, {
      fieldLabel : "Foo oo oo",
      plugins    : []
   }, {
      fieldLabel : "Foo oo oo oo",
      plugins    : []
   },]
});