/**
 * Created by andre on 15.10.18.
 */
Ext.define("demo.view.main.OverviewPanelController", {
   extend : "Ext.app.ViewController",
   alias  : "controller.demoOverviewPanelController",

   control : {
      bpcDemoTree : {
         select : "onDemoSelect"
      }
   },

   onDemoSelect : function (eventSource, demoRecord) {

      try {
         if (demoRecord.get("demoConfig")) {
            const target = this.getView().down("demoDemoArea");
            if (!demoRecord.demoViewer) {
               const newCmp = target.add({
                  xtype      : "demoDemoContainer",
                  demoConfig : demoRecord.get("demoConfig"),
                  record     : demoRecord,
               });
               demoRecord.demoViewer  = target.add(newCmp);
            }
            target.setActiveItem(demoRecord.demoViewer);
         }
      } catch (e) {
         Ext.log({
            msg   : `${this.self.getName()  }: ERROR onDemoSelect`,
            dump  : e,
            stack : true,
            level : "error"
         });
      }
   }

});