/**
 * Created by andre on 13.09.18.
 */
Ext.define("demo.view.widget.Calendar", {
   extend : "Ext.panel.Panel",
   layout : "fit",

   statics : {
      WIDGET_NAME        : "Calendar Demo",
      WIDGET_DESCRIPTION : "Show a Calendar Widget",
      WIDGET_ICON_CLS    : "x-fal fa-calendar"
   },

   initComponent : function () {
      Ext.log({ msg: `${this.self.getName()  }: initComponent`, level: "info" });
      this.items = [
         {
            xtype : "calendar",
            store : {
               autoLoad : true,
               proxy    : {
                  type        : "ajax",
                  url         : "bpc-fe-demo/resources/calendars.json",
                  extraParams : {
                     action : "getCalendars"
                  }
               }
            }
         }
      ];
      this.callParent();
   }
});