/**
 * Implementtion of the BpcInterface
 * Created by bnz on 31.08.17
 */
Ext.define("demo.BpcInterface", {
   extend : "BpcCommon.BpcInterface",

   requires : [
      "demo.view.widget.demoWidget",
      "demo.view.widget.demoBasicWidget",
      "demo.view.widget.demoMinimalWidget",
      "demo.view.widget.Calendar"
   ],

   config : {
      /**
         * An array of component-xtypes which will be added to the configuration GUI for this module. They
         * will get the Ext.data.Model of the corresponding module as parameter and can be used via this.module.
         */
      moduleConfigurationComponents : [],

      /**
         * A string which points to the baseModuleView, ExtJS class, string
         */
      baseModuleView : null,


      /**
         * A string which points to the mainView, ExtJS class, string
         */
      mainView : null,

      /**
         * A list of widgets (they should use the mixin BpcCommon.mixin.Widget), which will be offered to other modules.
         */
      widgets : [
         "demo.view.widget.demoWidget",
         "demo.view.widget.demoBasicWidget",
         "demo.view.widget.demoMinimalWidget",
         "demo.view.widget.Calendar"
      ],

      /**
         * Array of global event names, which should be forwarded to the backend.
         */
      forwardedEvents : [
         "chat" // used in demo.view.chat.ChatController
      ]
   }
});