Ext.define("demo.plugin.column.Column", {
   extend : "Ext.grid.column.Column",
   alias  : "widget.demoColumnPlugin",
    
   text : "✌ Demo Column",
    
   /**
     * @cfg producesHTML
     * @inheritdoc
     */
   producesHTML : false,
    
   defaultRenderer : function (value) {
      return `✌${  value  }✌`;
   },
    
   updater : function (cell, value) {
      Ext.fly(cell).down(this.getView().innerSelector, true).innerHTML
           = demo.view.plugin.Column.prototype.defaultRenderer.call(this, value);
   }
});