Ext.define("demo.DemoShiftColumn", {
   extend : "Ext.grid.Panel",
   alias  : "widget.demoShiftColumn",

   title  : "Shift Column",
   layout : {
      type  : "vbox",
      align : "stretch"
   },

   scrollable : true,
   store      : Ext.create("Ext.data.Store", {
      storeId : "simpsonsStore",
      fields  : ["Number"],
      data    :
            [
               { Number: "1" },
               { Number: "2" },
               { Number: "3" },
               { Number: "4" },
               { Number: "5" }
            ]
   }),

   columns :
    [
       { text: "Number",  dataIndex: "Number" },        
       { text: "shiftColumn", dataIndex: "shiftColumn", xtype: "bpcCommonShiftColumn", width: 200 }
    ],
   height : 200,
   width  : 1000
});