/**
 * Created by andre on 2019-08-23
 */
Ext.define("demo.view.components.EditableGrid", {
   extend : "Ext.Panel",
   alias  : "widget.demoEditableGrid",
    
   layout : "fit",

   title : "Editierbares Grid",
   items : [
      {
         xtype : "bpcEditableGrid",
    
    
         columns : [ // demo columns
            {
               header    : "Name",
               dataIndex : "name",
               editor    : "textfield"
            },
            {
               header    : "Email",
               dataIndex : "email",
               flex      : 1,
               editor    : {
                  xtype      : "textfield",
                  allowBlank : false
               }
            },
            {
               header    : "Phone",
               dataIndex : "phone"
            }
         ],
    
         store : { // demo store only!
            fields : ["name", "email", "phone"],
            data   : [
               { name: "Lisa", email: "lisa@simpsons.com", phone: "555-111-1224" },
               { name: "Bart", email: "bart@simpsons.com", phone: "555-222-1234" },
               { name: "Homer", email: "homer@simpsons.com", phone: "555-222-1244" },
               { name: "Marge", email: "marge@simpsons.com", phone: "555-222-1254" }
            ]
         }
      }
   ]
});