Ext.define("demo.DemoEditors", {
   extend : "Ext.tab.Panel",
   alias  : "widget.demoEditors",

   title : "Editoren",
   items : [
      {
         title : "JSON",
         xtype : "bpcJsonField",
         value : { eins: 1, zwei: 2 }
      },
      {
         title : "JavaScript",
         xtype : "bpcJavascriptField",
         value : "alert('Hello World')"
      },
      {
         title : "Groovy",
         xtype : "bpcGroovyField",
         value : "publishing {\n"
                + "    publications {\n"
                + "        maven(MavenPublication) {\n"
                + "            artifactId = bpcPrefix + packageName\n"
                + "            artifact('build/' + bpcPrefix + packageName +'.war') {\n"
                + "                extension 'war'\n"
                + "            }\n"
                + "        }\n"
                + "    }\n"
                + "    repositories {\n"
                + "        maven {\n"
                + "            name 'VirtimoMavenArtifactory'\n"
                + "            url version.endsWith('SNAPSHOT') ? snapshotsRepoUrl : releasesRepoUrl\n"
                + "            credentials {\n"
                + "                username = deployRepoUsername\n"
                + "                password = deployRepoPassword\n"
                + "            }\n"
                + "        }\n"
                + "    }\n"
                + "}\n"
                + "\n"
                + "defaultTasks 'run'\n"
                + "\n"
                + "//init some properties\n"
                + "project.ext {\n"
                + "  gitBranch  = \"unknown\"\n"
                + "  gitCommit = \"unknown\"\n"
                + "  gitDirtyState = \"unknown\"\n"
                + "  buildId = \"unknown\"\n"
                + "  buildTimestamp = new Date().format(\"yyyy-MM-dd'T'HH:mm:ssZ\")\n"
                + "}"
      },
      {
         title : "CSS",
         html  : "Coming soon"
      }
   ]
});