/**
 * Created by andre on 15.10.18.
 */
Ext.define("demo.view.main.Tree", {
   extend : "Ext.tree.Panel",
   alias  : "widget.bpcDemoTree",

   columns : [{
      xtype     : "treecolumn",
      dataIndex : "text",
      flex      : 1,
      renderer  : BpcCommon.Api.getTranslation
   }],

   store : {
      autoLoad : true,
      proxy    : {
         type : "ajax",
         url  : "bpc-fe-demo/resources/demoTree.json"
      }
   },

   dockedItems : [
      {
         xtype : "demoPluginHook",
         dock  : "bottom"
      }
   ]

});